import {
  select,
  csv,
  scaleLinear,
  extent,
  scaleBand,
  axisLeft,
  axisBottom,
  format,
  max
} from 'd3';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const render= data =>{
const margin={top:20, right:40, bottom:20, left:100};
const innerWidth=width-margin.left-margin.right;
const innerHeight=height-margin.top-margin.bottom;

const xvalue= d=>d.population;
const yvalue= d=>d.country;
  
//now for the scales
const Xscale= scaleLinear()
.domain([0, max(data, xvalue)])
.range([0, innerWidth])

const Yscale= scaleBand()
.domain(data.map(yvalue))
.range([0, innerHeight])
.padding(0.1)

const xAxis= axisBottom(Xscale);
const yAxis=axisLeft(Yscale);

const g= svg.append('g')
.attr('transform',`translate(${margin.left}, ${margin.top})`);

g.append('g').call(yAxis)
g.append('g').call(xAxis) 
.attr('transform', `translate(0, ${innerHeight})`)  
  
g.selectAll('rect')
.data(data)
.enter().append('rect')
.attr('width',d=>Xscale(xvalue(d)))
.attr('height',d=>Yscale(yvalue(d)))  
  
}

csv('data.csv')
.then(function(data){
data.forEach(function(d){
d.population=+d.population*1000;
})  
render(data)
});